image: node:16-alpine

stages:
  - install
  - build
  - publish
  - deploy

variables:
  TAG_LATEST: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:latest
  TAG_COMMIT: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:$CI_COMMIT_SHORT_SHA
  REPO: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME

install:
  stage: install
  script: 
    - npm install --production
  artifacts:
    expire_in: 1h
    paths:
      - node_modules/
  cache:
    paths:
      - node_modules/
  only:
    - main 

build:
  stage: build
  dependencies:
    - install
  variables:
    NODE_ENV: 'production'
  script:
    - npm run build
  artifacts:
    expire_in: 1h
    paths:
      - .next/
  only:
    - main

publish:
  image: docker:19.03.12
  stage: publish
  dependencies:
    - install
    - build
  services:
    - docker:dind
  script:
    - echo $ENV_FILE
    - cp $ENV_FILE .env
    - docker build -t $TAG_COMMIT -t $TAG_LATEST --target production .
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY
    - docker push $TAG_COMMIT
    - docker push $TAG_LATEST
  only:
    - main


deploy:
  image: alpine:latest
  stage: deploy
  tags:
    - deployment
  script:
    - chmod og= $ID_RSA
    - apk update && apk add openssh-client
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY"
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker pull $TAG_COMMIT"
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker container rm -f front-cafe-employee || true"
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker run -d -p 3002:3000 --name front-cafe-employee $TAG_COMMIT"
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker images | grep $REPO | awk 'NR!=1 { print; }'"
    - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker images | grep $REPO | awk 'NR!=1 { print \$3; }' | xargs docker rmi"
  environment:
    name: production
    url: http://82.146.39.215
  only:
    - main